import pygtk
pygtk.require('2.0')
import gtk
import csv

class Table:
	def callback(self, widget, data=None):
		print "Hello again - %s was pressed" % data
	
	def delete_event(self, widget, event, data=None):
		gtk.main_quit()
		return False
		
	def procurar(self, widget, data=None):
		card = widget.get_text()
		print card
		if card in self.cartas:
			colecao = self.cartas[card][1]
			carta = self.cartas[card][2]
			self.descricao_carta = "%s - %s" % (self.cartas[card][0], colecao)
			caminho = "setimages/%s/%s.jpg" % (colecao, carta)
			pixbuf = gtk.gdk.pixbuf_new_from_file(caminho)
			pixbuf = pixbuf.scale_simple(250,300,gtk.gdk.INTERP_BILINEAR)
			self.imagem.set_from_pixbuf(pixbuf)
		
	def __init__(self, cartas):
		self.cartas = cartas
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_title('MaginBook')
		self.window.set_size_request(400,400)
		self.window.connect('delete_event', self.delete_event)
		self.window.set_border_width(20)
		table = gtk.Table(3, 2, False)
		self.window.add(table)
		completar = gtk.EntryCompletion()
		self.liststore = gtk.ListStore(str)
		for s in self.cartas.iterkeys():
			self.liststore.append([s])
		completar.set_model(self.liststore)
		consulta = gtk.Entry()
		consulta.set_completion(completar)
		completar.set_text_column(0)
		completar.connect('match-selected', self.match_cb)
		consulta.connect('activate', self.procurar)
		table.attach(consulta, 0, 2, 0, 1)
		consulta.show()
		self.imagem = gtk.Image()
		#imagem.set_from_pixbuf(pixbuf)
		table.attach(self.imagem, 1, 2, 1, 2)
		self.imagem.show()
		
		self.status = gtk.Statusbar()
		table.attach(self.status, 0, 2, 2, 3)
		self.status.show()
		contexto_descricao_id = self.status.get_context_id('Informacao da Carta')
		consulta.connect('activate', self.informacao, contexto_descricao_id)
		table.show()
		self.window.show()
		
	def informacao(self, widget, data=None):
		self.status.push(data, self.descricao_carta)
		return
		
	def match_cb(self, completion, model, iter):
		card = model[iter][0]
		colecao = self.cartas[card][1]
		carta = self.cartas[card][2]
		caminho = "setimages/%s/%s.jpg" % (colecao, carta)
		pixbuf = gtk.gdk.pixbuf_new_from_file(caminho)
		pixbuf = pixbuf.scale_simple(250,300,gtk.gdk.INTERP_BILINEAR)
		self.imagem.set_from_pixbuf(pixbuf)		
		
		
def cartas():
	reader = csv.reader(open('sets/zendikarblock.txt'), delimiter = '\t')
	lista = {}
	for i in reader:
		lista[ i[0] ] = i
	return lista
		
def main():
	gtk.main()
	return 0
	
if __name__ == '__main__':
	Table(cartas())
	main()